#include <windows.h>

#include <fstream>
#include <iostream>
#include <conio.h>
#include <string>
#include <time.h>

using namespace std;

void WriteUsingStream(BYTE* pBytes, int nCount, char* filename)
{
	ofstream fStream(filename, ios::binary | ios::out);

	fStream.write((char*) pBytes, nCount);
	fStream.close();
}

int extractResource(const char * name, const char * type, char * file) {

	HMODULE hModule = GetModuleHandle(NULL);

	HRSRC hRsrc = FindResource(hModule, name, type);
	if (hRsrc == NULL) return 1; //couldn't find

	HGLOBAL hGlobal = LoadResource(hModule, hRsrc);
	if (hGlobal == NULL) return 1; //couldn't lock

	BYTE* pBytes = (BYTE*) LockResource(hGlobal);
	if (pBytes == NULL) return 1; //couldn't lock

	DWORD dwLength = SizeofResource(hModule, hRsrc);
	WriteUsingStream(pBytes, dwLength, file);
	UnlockResource(hGlobal);
	
	FreeResource(hGlobal);
	
	return 0;

}

void cleanup( string dir, string file ) {
	string command = "if EXIST ";
	command.append( dir );
	command.append( "\\" );
	command.append( file );
	command.append( " del " );
	command.append( dir );
	command.append( "\\" );
	command.append( file );
	system( command.c_str() );
}

void main() {
	string command;
	srand( time(0) );

	cout << "Greenstone3 Installer" << endl;
		
	//create the temp folder
	char id[6]; for( int i=0; i<5; i++ ) id[i] = (char)((rand()%26) + 97); id[5] = '\0'; //id for this instance
	string tempdir = "greenstone3.tmp"; tempdir.append( id ); //the temp dir

	cout << "Creating temp folder '";
	cout << tempdir;
	cout << "' ..." << endl;	
	command = "mkdir ";	command.append(tempdir);
	system( command.c_str() );
	
	//extract the resources
	cout << "Extracting search4j tool ..." << endl;
	string search4jLocation = ""; search4jLocation.append( tempdir ); search4jLocation.append( "\\search4j.exe" );
	extractResource( "SEARCH4J", "EXE", (char*) search4jLocation.c_str() );
	
	cout << "Extracting jar installer ..." << endl;
	string jarLocation = ""; jarLocation.append( tempdir ); jarLocation.append( "\\greenstone3.jar" );
	extractResource( "GREENSTONE_JAR", "JAR", (char*) jarLocation.c_str() );
	
	//change to the temp directory
	SetCurrentDirectory( tempdir.c_str() );

	//check if an appropriate java is found
	bool jvmFound = (system( "search4j.exe -m @java.min.version@" ) == 0);
	
	//if the jvm was not found, try to fix it and find it
	if ( !jvmFound ) {
		//did not find a good java
		cout << "Greenstone requires java @java.min.version@ or greater" << endl;
		
		//tell them if java is absent or just too old
		if ( system( "search4j.exe" ) == 0 ) {
			cout << "Your java is too old." << endl;
		} else {
			cout << "Could not find java." << endl;
		}
		
		//is this an installer with the bundled JRE?
		cout << "Checking for bundled java ..." << endl;
		int extract_result = extractResource( "JAVA", "EXE", "@java.installer@" );
		if ( extract_result == 0 ) {
			//yes, JRE is bundled
			cout
				<< "This installer comes bundled with a suitible version of java: " << endl
				<< "   @java.installer@" << endl
				<< "Do you want to install this java? (y/n)" << endl;
			char r[1024]; cin >> r;
			if ( _stricmp( r, "y" ) == 0 ) {
				system( "@java.installer@" );
				jvmFound = true; //assume the java installation went well
			}
		} else {
			//no, JRE is not bundled
			cout << "Sorry, there is no bundled java with this installer" << endl;
			cout << "Install java (@java.min.version@ or newer) and try again" << endl;
			cout << "Or, download a greentsone3 installer with bundled java and use that instead of this one" << endl;
		}
	}
	
	//if we have found it by now, launch the installer
	if ( jvmFound ) {
		//launch the jar with search4j, taking a note of the exit code
		cout << "Launching Installer ..." << endl;
		int launch_exit_code = 0;
		launch_exit_code = system("search4j.exe -m @java.min.version@ -l greenstone3.jar");
		
		//report how it went
		if ( launch_exit_code == 0 ) {
			cout << "Setup complete" << endl;
		} else {
			cout << "Still could not find a suitible version of java" << endl;
			cout << "Please install java and try again" << endl;
		}
	}
	
	//change back to the original directory and clean up the temp directory
	SetCurrentDirectory("..");

	cleanup(tempdir, "greenstone3.jar" );
	cleanup(tempdir, "search4j.exe");
	cleanup(tempdir, "ant.install.log");
	cleanup(tempdir, "@java.installer@");
	
	command = "rmdir ";
	command.append( tempdir );
	system( command.c_str() );
	cout << "Press any key to exit..." << endl;
	getch();
	
}
